import fetch from 'isomorphic-fetch';

const opts = {};

function myFetch(url, opt) {
  return new Promise(async (resolve) => {
    const result = await fetch(url, opt);
    resolve(result.json());
  });
}

async function $fetch(url, option = {}) {
  return myFetch(url, option);
}

async function $get(url) {
  const getOpts = Object.assign({
    method: 'GET'
  }, opts);
  return await myFetch(`${url}?t=${+new Date()}`, getOpts);
}

async function $post(url, data) {
  const postOpts = Object.assign({
    method: 'POST'
  }, opts);
  if (data) {
    postOpts.body = JSON.stringify(data);
  }
  return await myFetch(url, postOpts);
}

export default {
  fetch: $fetch,
  get: $get,
  post: $post,
  install: (Vue, options) => {
    Object.assign(opts, options);
    Vue.mixin({
      methods: {
        $fetch,
        $get,
        $post
      }
    });
  }
};
